﻿using Newtonsoft.Json;

namespace TestProject;

/// <summary>
/// 요청 메시지
/// </summary>
public class RequestMessage
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 메시지 리스트 - MessageList

    /// <summary>
    /// 메시지 리스트
    /// </summary>
    [JsonProperty("messages")]
    public List<Message> MessageList { get; set; }

    #endregion
    #region Top P - TopP

    /// <summary>
    /// TopP
    /// </summary>
    [JsonProperty("topP")]
    public double TopP { get; set; }

    #endregion
    #region Top K - TopK

    /// <summary>
    /// TopK
    /// </summary>
    [JsonProperty("topK")]
    public int TopK { get; set; }

    #endregion
    #region 최대 토큰 카운트 - MaximumTokenCount

    /// <summary>
    /// 최대 토큰 카운트
    /// </summary>
    [JsonProperty("maxTokens")]
    public int MaximumTokenCount { get; set; }

    #endregion
    #region 온도 - Temperature

    /// <summary>
    /// 온도
    /// </summary>
    [JsonProperty("temperature")]
    public double Temperature { get; set; }

    #endregion
    #region 반복 패널티 - RepeatPenalty

    /// <summary>
    /// 반복 패널티
    /// </summary>
    [JsonProperty("repeatPenalty")]
    public double RepeatPenalty { get; set; }

    #endregion
    #region Stop Before - StopBefore

    /// <summary>
    /// Stop Before
    /// </summary>
    [JsonProperty("stopBefore")]
    public List<string> StopBefore { get; set; }

    #endregion
    #region AI 필터 포함 여부 - IncludeAIFilters

    /// <summary>
    /// AI 필터 포함 여부
    /// </summary>
    [JsonProperty("includeAiFilters")]
    public bool IncludeAIFilters { get; set; }

    #endregion
    #region 시드 - Seed

    /// <summary>
    /// 시드
    /// </summary>
    [JsonProperty("seed")]
    public int Seed { get; set; }

    #endregion
}