﻿using Newtonsoft.Json;

namespace TestProject;

/// <summary>
/// 스트리밍 데이터 결과
/// </summary>
public class StreamingDataResult : StreamingDataBase
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 메시지 - Message

    /// <summary>
    /// 메시지
    /// </summary>
    [JsonProperty("message")]
    public Message Message { get; set; }

    #endregion
    #region 입력 길이 - InputLength

    /// <summary>
    /// 입력 길이
    /// </summary>
    [JsonProperty("inputLength")]
    public long InputLength { get; set; }

    #endregion
    #region 출력 길이 - OutputLength

    /// <summary>
    /// 출력 길이
    /// </summary>
    [JsonProperty("outputLength")]
    public long OutputLength { get; set; }

    #endregion
    #region 중단 사유 - StopReason

    /// <summary>
    /// 중단 사유
    /// </summary>
    [JsonProperty("stopReason")]
    public string StopReason { get; set; }

    #endregion
    #region 시드 - Seed

    /// <summary>
    /// 시드
    /// </summary>
    [JsonProperty("seed")]
    public long Seed { get; set; }

    #endregion
    #region AI 필터 리스트 - AIFilterList

    /// <summary>
    /// AI 필터 리스트
    /// </summary>
    [JsonProperty("aiFilter")]
    public List<AIFilter> AIFilterList { get; set; }

    #endregion
}