﻿namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private
    ////////////////////////////////////////////////////////////////////// Event

    #region 클라이언트 메시지 도착시 처리하기 - client_MessageArrived(sender, message)

    /// <summary>
    /// 클라이언트 메시지 도착시 처리하기
    /// </summary>
    /// <param name="sender">이벤트 발생자</param>
    /// <param name="message">이벤트 인자</param>
    private static void client_MessageArrived(object sender, StreamingMessage message)
    {
        if(message.Data is StreamingDataToken token)
        {
            Console.Write(token.Message.Content);
        }
    }

    #endregion

    ////////////////////////////////////////////////////////////////////// Function

    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    static async Task Main()
    {
        string clovaStudioAPIKey = "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"; // X-NCP-CLOVASTUDIO-API-KEY
        string apiGatewayAPIKey  = "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX";                         // X-NCP-APIGW-API-KEY

        using APIClient client = new APIClient(clovaStudioAPIKey, apiGatewayAPIKey);

        client.MessageArrived += client_MessageArrived;

        List<Message> messageList =
        [
            new Message { Role = "system", Content = "당신은 서울 관광 전문 가이드 입니다."     },
            new Message { Role = "user"  , Content = "서울 북촌에 있는 맛집을 3곳 추천해주세요."}
        ];

        RequestMessage request = new RequestMessage();

        request.MessageList       = messageList;
        request.TopP              = 0.8d;
        request.TopK              = 0;
        request.MaximumTokenCount = 256;
        request.Temperature       = 0.5d;
        request.RepeatPenalty     = 5.0d;
        request.StopBefore        = new List<string>();
        request.IncludeAIFilters  = true;
        request.Seed              = 0;

        Console.WriteLine(messageList[1].Content);
        Console.WriteLine();

        List<StreamingMessage> streamingMessageList = await client.RequestChatStream(request);
    }

    #endregion
}